//***************************************************************************//
// the Art of Re-Touch
// by fi5e and eyebeam <http://ni9e.com> <http://eyebeam.org>
// Started 10 Octobber 2005
// (comment out param() calls to compile and run locally)
//***************************************************************************//

//semi-constants
//SMALL
//int WIN_W = 800;  
//int WIN_H = 570;
//MEDIUM
int WIN_W = 800;  
int WIN_H = 640;
//FULL
//int WIN_W = 910;  
//int WIN_H = 670;

int MAX_W = 525;
int MAX_H = 504;

int I_MIN = 150;

//Set up vars
PImage before, after, display, result, load_image, logo;
int i_width, i_height;

int threshold;
int diff;
float amplify = 5.0f;
float amp_max = 10;

int num_files = 49;
int cur_file = 1;

boolean mouse = false;
boolean mouse_r = false;
boolean interactive = false;
int algor = 4;
boolean change = true;

int offsetX = 40;
int offsetY = 60;

color newColor;
int r, g, b;
int r_dif, g_dif, b_dif;

int xmouse, ymouse;
float pct;

int counter = 0;

String title[]         = {
  "", "ALTERED PIXELS (RGB)", "ALTERED PIXELS", "UN-ALTERED PIXELS", "BEFORE VS AFTER (THRESHOLD)", "UN-ALTERED PIXELS (GREYSCALE)", "ALTERED PIXELS (ABSTRACT)", "BEFORE VS AFTER (INTERPOLATION)"};
String description[]   = {
  "", "Pixels that have been altered for each red, green, and blue color value.",
  "Pixels that have been altered.",
  "Pixels that have NOT been altered.",
  "Left side is before re-touching, right side is after.",
  "Pixels that have been altered. White value denotes amount of change",
  "Pixels that have been altered",
  "Left side is before re-touching, right side is after.",
};

//buttons
Button BT;
Button BTS[];
String method_title = "NOTHING YET...";
String method_description = "NOTHING YET...";

Dragger DGR;

auto_B AB;
Prev_Next PRV, NXT;
int b_size = 15;
int space  = 4;
color highlight = color(156, 0, 0);

String before_files[];
String after_files[];


PFont reg_10, bold_10, reg_12, bold_12, bold_16;

int loader = 0;

//DATA SET
int data_set = 1;
//shows up on site
String data_URL[] = {
  "", "www.glennferon.com", "sets from gelennferon.com", "www.retouchme.co.uk", "www.conraddigital.com", "www.nasonart.com", "homepage.mac.com/gapodaca", "www.datepixs.com", "www.nyphotographics.com", "www.phojoe.com", "www.touchofglamour.com"};
//acutal URL links
String actual_URL[] = {
  "", "http://www.glennferon.com", "http://www.glennferon.com", "http://www.retouchme.co.uk", "http://www.conraddigital.com", "http://www.nasonart.com/retouchmain.html", "http://homepage.mac.com/gapodaca/digital/digital.html", "http://www.datepixs.com/", "http://www.nyphotographics.com/retouching/index2.htm", "http://www.phojoe.com/portrait_retouching.html", "http://www.touchofglamour.com/Photo_Retouching.htm"};

int data_files[] = {
  0, 45, 4, 18, 9, 15, 8, 9, 16, 9, 8}; 
  
String dir = "";


String data_folder[] = {
  "", "ferron", "ferron_set", "retouchme", "conrad", "nasonart", "gregs", "datepixs", "nyphotographics", "phojoe", "touchofglamour"};
int num_URLS = 10+1;
Data_Button DT;
Data_Button DTS[];
Link_Button LINK;

int below_image = 50;

String modes[] = {
  "", P2D, P3D, JAVA2D, OPENGL};
int mode;
String defaultMessage, inputFromPage;
String bs;
int bi;

int min_x = 385;

//**************************************
void setup(){

  size(WIN_W, WIN_H, P3D);  //set up window


  method_title = title[algor];
  method_description = description[algor];

  before_files = new String[(num_files+2)];
  after_files  = new String[(num_files+2)];

  //CHECK IF VARS HAVE BEEN PASSED IN VIA HTML
  //image number
  String s_image;
  s_image = trim(param("img"));
  //s_image = "6";
  if(s_image != ""){
    cur_file = Integer.parseInt(s_image);
  }

  //dir = "nasonart";
  dir = trim(param("set")); 
   if(dir != ""){  //if a value was passed from HTML
    for(int i=1; i<num_URLS; i++){
      println(dir + " -- " + data_folder[i]);
      //if(dir.equals(data_folder[i])){
      if(data_folder[i].equals(dir)){
        
        data_set = i;
        println("the folder index = " + i);       
      } 
    }
  }
  
 load_data(data_folder[data_set], data_files[data_set]);

  reg_10  = loadFont("data/ArialMT-10.vlw");
  bold_10  = loadFont("data/Arial-BoldMT-10.vlw");
  reg_12  = loadFont("data/ArialMT-12.vlw");
  bold_12 = loadFont("data/Arial-BoldMT-12.vlw");
  bold_16 = loadFont("data/Arial-BoldMT-18.vlw");


  //create buttons
  BTS = new Button[8];
  for(int i = 1; i < 8; i++)
  {
    BT = new Button(offsetX + (b_size * (i-1)) + (space * (i-1)), offsetY - b_size - 17 , b_size, b_size, i);
    BTS[i] = BT;
  }
  //creat link button
  LINK = new Link_Button(580, 16, 130, 20, 1, "Link to This Image", "nothing", bold_12);
  
  //create data buttons
  DTS = new Data_Button[num_URLS];
  for(int i=1; i<num_URLS; i++){
    DT = new Data_Button(offsetX + i_width + b_size, offsetY + (b_size * (i-1)) + ((b_size/2) * (i-1)), b_size, b_size, i, data_URL[i], actual_URL[i], reg_12);
    DTS[i] = DT;
    println("created data button x " + i);
  }

  //create auto and previous and next buttons
  AB = new auto_B((offsetX + i_width - b_size), (offsetY - b_size - 17),  b_size, b_size);
  PRV = new Prev_Next(offsetX -12, (offsetY + i_height + 20) + below_image, 100, 30, true, bold_16, highlight, "  Previous");
  NXT = new Prev_Next(offsetX -6 + i_width, (offsetY + i_height + 10) + below_image, 100, 30, false, bold_16, highlight, "Next");

  //CREATE DRAGGER
  DGR = new Dragger();

  
  refresh(cur_file);  //loads in image

}
//**************************************
void draw(){
  background(255);

  //DISPLAY INPUT DATA FROM URL FOR TESTING
  //color(highlight);
  //textFont(bold_12, 12);
  //text(bs, 600, 500);

  //NEED ONE FRAME BETWEEN CLICK AND ACTION TO DRAW LOAD SCREEN
  loader++;
  if(loader == 1){
    draw_loader();
  }
  else if(loader == 2){
    refresh(cur_file);
  }

  pct = float(xmouse) / float(i_width);

  if(mouse && in_box()){
    //IF MOUSE IS PRESSED IN THE BOX CREATE THRESHOLD VAL BASED ON MOUSEX POS
    xmouse = mouseX - offsetX;
    if (xmouse < 0){
      xmouse = 0;
    }
    if (xmouse > i_width){
      xmouse = i_width;
    }

  }

  //IF IN WE ARE IN AUTOMATIC ANIMATION MODE....
  if(interactive == false){
    counter+=2;
    if(counter > 360){
      counter = 0;
    }
    float sin_temp = ((cos(radians(counter))) * .5) + .5;

    xmouse = int((sin_temp * i_width));

  }

  float xpos = float(xmouse) / float(i_width);
  threshold = int(255 - ((255.0f * xpos) + 2));

  // Differencing.....
  if((mouse && in_box()) || change || interactive==false){
    for(int i=0; i<(i_width*i_height); i++) {
      //check rgb vals
      r_dif = int(red(result.pixels[i]));
      g_dif = int(green(result.pixels[i]));
      b_dif = int(blue(result.pixels[i]));


      switch (algor) {
      case 1:  
        //method_title = "ALTERED PIXELS (BY RGB VALUES)";
        if( r_dif > threshold){
          r = int(r_dif * amplify);
        }
        else{
          r = 0;
        }
        if( g_dif > threshold){
          g = int(g_dif * amplify);
        }
        else{
          g = 0;
        }
        if( b_dif > threshold){
          b = int(b_dif * amplify);
        }
        else{
          b = 0;
        }
        break;
      case 2:  
        //method_title = "ALTERED PIXELS (BY PIXEL VALUES)";
        if(r_dif > threshold || g_dif > threshold || b_dif > threshold){
          r = int(red(after.pixels[i]));
          g = int(green(after.pixels[i]));
          b = int(blue(after.pixels[i]));

        }
        else{
          r = g = b = 0;
        }
        break;
      case 3:  
        //method_title = "UN-ALTERED PIXELS (BY PIXEL VALUES)";
        if(r_dif > threshold || g_dif > threshold || b_dif > threshold){
          r = g = b = 255;
        }
        else{
          r = int(red(before.pixels[i]));
          g = int(green(before.pixels[i]));
          b = int(blue(before.pixels[i]));
        }
        break;
      case 4:  
        //method_title = "BEFORE VS AFTER (THRESHOLD)";
        if( r_dif > threshold){
          r = int(red(after.pixels[i]));
        }
        else{
          r = int(red(before.pixels[i]));
        }

        if( g_dif > threshold){
          g = int(green(after.pixels[i]));
        }
        else{
          g = int(green(before.pixels[i]));
        }

        if( b_dif > threshold){
          b = int(blue(after.pixels[i]));
        }
        else{
          b = int(blue(before.pixels[i]));
        }
        break;
      case 5:  
        //method_title = "UN-ALTERED PIXELS (GREYSCALE)";
        if( r_dif > threshold || g_dif > threshold || b_dif > threshold){
          int temp_av = (r_dif + g_dif + b_dif)/3;
          r = g = b = int(temp_av  * amplify);
        }
        else{
          r = g = b = 0;
        }
        break;
      case 6:  
        //method_title = "ALTERED PIXELS (PSYCHEDELIC)";
        if( r_dif > threshold || g_dif > threshold || b_dif > threshold){
          r = int(r_dif * amplify);
          g = int(g_dif * amplify);
          b = int(b_dif * amplify);
        }
        break;
      case 7:  
        //method_title = "BEFORE VS AFTER (INTERPOLATION)";
        r = int((red(after.pixels[i]) * pct) + (red(before.pixels[i]) * (1.0 - pct)));
        g = int((green(after.pixels[i]) * pct) + (green(before.pixels[i]) * (1.0 - pct)));
        b = int((blue(after.pixels[i]) * pct) + (blue(before.pixels[i]) * (1.0 - pct)));
        break;

      default: 
        //println("return zero on your asssssss");
        break;
      }//end switch

      //UPDATE PIXELS
      newColor = color(r, g, b);
      display.pixels[i] = newColor;
    }//end for loop

    display.updatePixels();


  }//end if differencing

  if(loader > 2){
    image(display, offsetX, offsetY);
  }

  //draw crop marks
  stroke(100);
  strokeWeight(1);

  line(xmouse + offsetX ,offsetY,  xmouse + offsetX, offsetY - 10);
  line(xmouse + offsetX ,offsetY + i_height,  xmouse + offsetX ,offsetY + 10 + i_height);

  //draw boarder
  line(offsetX, offsetY, offsetX+i_width, offsetY);
  line(offsetX, offsetY + i_height, offsetX+i_width, offsetY + i_height);
  line(offsetX, offsetY, offsetX, offsetY + i_height);
  line(offsetX + i_width, offsetY, offsetX + i_width, offsetY + i_height);

  //DRAGGER BAR
  line(offsetX, offsetY +i_height+ 20, offsetX + i_width, offsetY +i_height+ 20);

  //**********TEXT STUFF***********
  //"brightness" and "threshold"
  fill(0);
  textFont(reg_10, 10);
  //text("threshold", xmouse + offsetX - 47, offsetY - 5);
  text((100 - int(pct*100)) + "%", xmouse + offsetX + 5, offsetY - 3);

  //STATIC TYPE
  fill(highlight);
  textFont(bold_12, 12);
  text("DIFFERENCING METHOD:", offsetX, offsetY - 48);

  text("AUTO:", offsetX + i_width + (b_size * 2), offsetY + 8);

  //Title
  fill(0);
  textFont(bold_12, 12);
  text(method_title, offsetX + 135, offsetY - 31);

  fill(0);
  textFont(reg_12, 12);
  text(method_description, offsetX, offsetY - 15);


  //IMAGE NUMNER
  fill(0);
  textFont(bold_10, 10);
  if((offsetX + (i_width/2) + 1) > I_MIN){
    int temp = -50;
    text(cur_file, offsetX + (i_width/2) + 1, offsetY + i_height + 70);
    text("/", offsetX + (i_width/2) + 13, offsetY + i_height + 70);
    text(num_files, offsetX + (i_width/2) +17, offsetY + i_height + 70);
  }
  else{
    int temp = -30;
    text(cur_file, 200 + 1 + temp, offsetY + i_height + 70);
    text("/", 200 + 13 + temp, offsetY + i_height + 70);
    text(num_files, 200 + 17 + temp, offsetY + i_height + 70);
  }

  //**********BUTTON STUFF***********
  //mode buttons
  change = false;
  method_title = title[algor];
  for(int i=1; i<8; i++){
    if(BTS[i].draw(mouseX, mouseY, mouse_r, algor)){
      if(BTS[i].state == 1){  //on press
        algor = i; 
        method_title = title[algor];
        method_description = description[algor];
        change=true;
      }
      else if(BTS[i].state == 2){  //on roll over
        method_title = title[i];
      }
    }
  }

  //LOAD IMAGES FROM
  fill(highlight);
  textFont(bold_12, 12);
  text("SELECT DATA SOURCE:", offsetX + i_width + (b_size * 2), offsetY + 55);

  //DATA URL BUTTONS
  for(int i=1; i<num_URLS; i++){
    if(DTS[i].draw(mouseX, mouseY, mouse_r, data_set)){
      data_set = i; 
      load_data(data_folder[data_set], data_files[data_set]); 
      change=true;
      loader = 0;
      cur_file = 1;
    }
  }

  //LINK BUTTON
  LINK.draw(mouseX, mouseY, mouse_r);

  //interactive check box
  if(AB.draw(mouseX, mouseY, mouse_r, interactive)){ 
    interactive = true;
  }
  else{
    interactive = false;
  }
  if(in_box() && mouse){
    interactive = true;
  }       
  if(PRV.draw(mouseX, mouseY, mouse_r)){
    cur_file--;
    if(cur_file < 1){
      cur_file = num_files;
    }
    change=true;   
    loader = 0;        
    //refresh(cur_file); 
  }
  if(NXT.draw(mouseX, mouseY, mouse_r)){
    cur_file++;
    if(cur_file > num_files){
      cur_file = 1;
    }
    change=true;
    loader = 0;        
  }

  //DRAGGER
  DGR.draw(mouseX, mouseY, xmouse + offsetX, mouse);
  fill(highlight);
  textFont(bold_12, 12);
  //text("DRAG", xmouse + offsetX - 6, offsetY + i_height + 50);

  //NEEDS TO BE SET FOR RELEASE STATE 
  mouse_r = false;
  
  //for testing HTML input
  //textFont(bold_16, 18);
  //text("with trims()?.. dir = " + dir, 500, 500);

}


//**************************************

void keyPressed() { 
  if(key == 'w') {
    cur_file++;
    if(cur_file > num_files){
      cur_file = 1;
    }
    refresh(cur_file);
  }
  if(key == 'q') {
    cur_file--;
    if(cur_file < 1){
      cur_file = num_files;
    }
    refresh(cur_file);
  }
  if(key == '1'){
    algor = 1;
  }
  if(key == '2'){
    algor = 2;
  }
  if(key == '3'){
    algor = 3;
  }
  if(key == '4'){
    algor = 4;
  }
  if(key == '5'){
    algor = 5;
  }
  if(key == '6'){
    algor = 6;
  }
  if(key == '7'){
    algor = 7;
  }
  if(key == 'p'){
    if(interactive == true){
      interactive = false;
    }
    else{
      interactive = true;
    }
  }
}


//**************************************
void refresh(int num){

  before = loadImage(before_files[num]);
  after = loadImage(after_files[num]);
  display = before.get();
  result  = before.get();

  i_width  = before.width;
  i_height = before.height;


  //DIFFERNCE ON LOAD AND SAVE IN PImage result
  for(int i=0; i<(i_width*i_height); i++) {
    //check rgb vals
    r_dif = int(abs((red(before.pixels[i])+512) - (red(after.pixels[i])+512)));
    g_dif = int(abs((green(before.pixels[i])+512) - (green(after.pixels[i])+512)));
    b_dif = int(abs((blue(before.pixels[i])+512) - (blue(after.pixels[i])+512)));

    //UPDATE PIXELS
    newColor = color(r_dif, g_dif, b_dif);
    result.pixels[i] = newColor;

  }//end pixel for loop

  //update button positions
  for(int i = 1; i < 8; i++)
  {
    BTS[i].update(offsetX + (b_size * (i-1)) + (space * (i-1)), offsetY - b_size - 30, b_size, b_size);
  }

  for(int i=1; i<num_URLS; i++){
    DTS[i].update(offsetX + i_width + (b_size * 2), offsetY + (b_size * (i-1)) + ((b_size/2) * (i-1)) + 60, b_size, b_size);
  }

  AB.update((offsetX + i_width + (b_size * 2)), offsetY + 12,  b_size, b_size);


  PRV.update(offsetX -25, (offsetY + i_height + 1) + below_image, 100, 30);

  if((offsetX -110 + i_width) > I_MIN){
    NXT.update(offsetX - 50 + i_width, (offsetY + i_height + 1) + below_image, 80, 30);
  }
  else{
    NXT.update(250, (offsetY + i_height + 1) + below_image, 100, 30);
  }

  DGR.update(xmouse + offsetX + 5, offsetY + i_height + 10, 12, 26);

  xmouse = i_width / 2;



}
//**************************************

//**************************************
boolean in_box(){
  //IS THE MOUSE OVER THE MAIN IMAGE?
  if(mouseX>offsetX && (mouseX<offsetX+i_width) && mouseY>offsetY && mouseY<(offsetY+i_height + 60)){
    return true;
  }
  else{
    return false;
  }
}

//**************************************
void mousePressed(){
  mouse = true;

}
//**************************************
void mouseReleased(){
  mouse = false;
  mouse_r = true;
  //println("mouse released");
}
//**************************************
void mouseDragged() 
{ 
  mouse_r = false; 
} 
//**************************************
void draw_loader(){
  //draw loading frame
  fill(255);
  stroke(100);
  //draw boarder
  line(offsetX, offsetY, offsetX+i_width, offsetY);
  line(offsetX, offsetY + i_height, offsetX+i_width, offsetY + i_height);
  line(offsetX, offsetY, offsetX, offsetY + i_height);
  line(offsetX + i_width, offsetY, offsetX + i_width, offsetY + i_height);
  rect(offsetX, offsetY, i_width, i_height);


  fill(highlight);
  textFont(bold_16, 18);
  text("Loading...", offsetX + (i_width/2) - 50, offsetY + (i_height/2) );
}
//**************************************
void load_data(String folder, int file_count){

  for(int i=0; i<=file_count; i++){
    String tempB = "images/med/" + folder + "/before_" + i + ".jpg";
    String tempA = "images/med/" + folder + "/after_"  + i + ".jpg";
    before_files[i] = tempB;
    after_files[i]  = tempA;
    println("created before_files[] = " + i);
  }

  num_files = data_files[data_set];

}
//**************************************

